from common.utils.config import Config as GlobalConfig


class Config(GlobalConfig):
    FLOW_DATA_SOURCE = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "FLOW_DATA_SOURCE", fallback="correlated_flow_viz"
    )

    CONFIG_DATA_SOURCE = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "CONFIG_DATA_SOURCE", fallback="pace2druid_manager_realization_config"
    )

    INTENT_DATA_SOURCE = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "INTENT_DATA_SOURCE", fallback="pace2druid_policy_intent_config"
    )

    FLOW_QUERY_GRANULARITY = GlobalConfig.CONFIG.get("NETWORK_TRAFFIC_DROP", "FLOW_QUERY_GRANULARITY", fallback="day")

    FLOW_QUERY_ALL_GRANULARITY = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "FLOW_QUERY_ALL_GRANULARITY", fallback="all"
    )

    BASELINE_MAX_RETENTION_DAYS = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "BASELINE_MAX_RETENTION_DAYS", fallback="30"
    )

    BASELINE_MAX_HISTORICAL_CREATION_DAYS = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "BASELINE_MAX_HISTORICAL_CREATION_DAYS", fallback="7"
    )

    PERSIST_LOW_CONFIDENCE_EVENTS_AS_SILENT = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "PERSIST_LOW_CONFIDENCE_EVENTS_AS_SILENT", fallback="False"
    )

    MIN_BASELINE_DURATION_DAYS = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "MIN_BASELINE_DURATION_DAYS", fallback="3"
    )

    NUMBER_OF_PERMITTED_EVENTS = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "NUMBER_OF_PERMITTED_EVENTS", fallback="3000"
    )

    NUMBER_OF_LINES_OF_LOGS = GlobalConfig.CONFIG.get("DF_LOGGER", "NUMBER_OF_LINES_OF_LOGS", fallback="100")

    EVENT_METADATA_COMPUTE_LIMIT = GlobalConfig.CONFIG.get(
        "NETWORK_TRAFFIC_DROP", "EVENT_METADATA_COMPUTE_LIMIT", fallback="500"
    )
