class Const:
    # general
    TENANT_ORG_ID = "TENANT_ORG_ID"

    # dimension
    SRC_VM_ID = "srcVmId"
    DST_VM_ID = "dstVmId"
    SRC_PORT = "srcPort"
    DST_PORT = "dstPort"
    SRC_RULE_ID = "srcRuleIds"
    DST_RULE_ID = "dstRuleIds"
    SRC_SITE_ID = "srcSiteId"
    DST_SITE_ID = "dstSiteId"
    SRC_COMPUTE_TYPE = "srcComputeType"
    DST_COMPUTE_TYPE = "dstComputeType"
    VM_COMPUTE_TYPE = "VM"
    DST_IP_TYPE = "destIpType"
    TIMESTAMP = "timestamp"
    TIME = "__time"
    DISPLAY_NAME = "display_name"
    IS_SRC_INFO_PRESENT = "isSrcInfoPresent"
    IS_DST_INFO_PRESENT = "isDstInfoPresent"

    # aggregate
    SRC_FW_BLOCKED = "srcFwBlocked"
    SRC_FW_ALLOWED = "srcFwAllowed"
    DST_FW_BLOCKED = "dstFwBlocked"
    DST_FW_ALLOWED = "dstFwAllowed"
    EXT_SRC_ALLOWED = "extSrcAllowed"
    EXT_DST_ALLOWED = "extDstAllowed"
    OPPOSITE_SIDE = "oppositeSide"

    # virtual column

    # if (like(srcVmId, 'IP-%') || (!like(destIpType, 'UCAST') && (srcFwAllowed < dstFwAllowed) ), dstFwAllowed, 0)"
    EXT_SRC_ALLOWED_VCOL = (
        f"if (like({SRC_VM_ID}, 'IP-%') || (!like({DST_IP_TYPE}, 'UCAST') &&"
        f" ({SRC_FW_ALLOWED} < {DST_FW_ALLOWED}) ), {DST_FW_ALLOWED}, 0)"
    )

    # if (like(dstVmId, 'IP-%'), srcFwAllowed, 0)
    EXT_DST_ALLOWED_VCOL = f"if (like({DST_VM_ID}, 'IP-%'), {SRC_FW_ALLOWED}, 0)"

    # post aggregation
    TOTAL_BLOCKED = "totalBlocked"
    TOTAL_ALLOWED = "totalAllowed"
    TOTAL = "total"
    ALLOW_RATIO = "allowRatio"
    BLOCK_RATIO = "blockRatio"
    COMBINED_SRC_ALLOW = "combinedSrcAllowed"
    COMBINED_DST_ALLOW = "combinedDstAllowed"

    # derived baseline columns
    SIGMA_STD_DEV = "sigmaStdDev"
    BLOCKED_STD = "blockedStdDeviation"
    ALLOWED_RATIO_MEAN = "allowRatioMean"
    BLOCKED_MEAN = "blockedMean"
    BLOCKED_RATIO_MEAN = "blockedRatioMean"
    ALLOWED_MEAN = "allowMean"
    TOTAL_MEAN = "totalMean"
    BASELINE_DURATION = "baselineDuration"

    # score & misc
    VM_ID = "vmId"
    MAX_SCORE = 100
    WEIGHTED_SCORE = "Score"
    BLOCKED_STD_SCORE = "stdDevScore"
    TREND_CHANGE_NORM_FACTOR = "trendChangeNormFactor"
    TREND_CHANGE_DIFF = "trendChangeDiff"
    TREND_CHANGE_SCORE = "trendChange"
    BASELINE_PORT_CARDINALITY_SUM = "baselinePortCardinalitySum"
    TODAY_PORT_CARDINALITY_SUM = "todayPortCardinalitySum"
    CARDINALITY_SCORE = "cardinalityScore"
    CARDINALITY_COUNT = "cardinalityCount"
    TODAY_SUFFIX = "_T"
    BASELINE_SUFFIX = "_B"
    TODAY_CARDINALITY_COUNT = CARDINALITY_COUNT + TODAY_SUFFIX
    BASELINE_CARDINALITY_COUNT = CARDINALITY_COUNT + BASELINE_SUFFIX
    NEW_PORT_MAX_SCORE = 100.0
    IS_SILENT = "is_silent"
    EVENT_TIME = "event_time"

    # Event/Config dimension & function
    RULE_ID = "rule_id"
    CONFIG_TYPE = "config_type"
    POLICY_PATH = "policy_path"
    POLICY_PATH_FROM_TAG = "policy_path_from_tag"
    REVISION = "revision"
    STRING_LAST_NSX = "stringLastNsx"
    MANAGER_DFW_RULE = "MANAGER_DFW_RULE"
    POLICY_DFW_RULE = "POLICY_DFW_RULE"
    NSX_I = "NSX_I"
    # Should be NETWORK_TRAFFIC_DROP, but yaml is this name for report_type
    REPORT_TYPE = "TRAFFIC_DROP"

    # Other
    EXTERNAL_VM_ID = "External"
    INTERNAL_VM_ID = "Internal"

    SCORE_WEIGHTAGE = {BLOCKED_STD_SCORE: 50.0, TREND_CHANGE_SCORE: 25.0, CARDINALITY_SCORE: 25.0}

    DEFAULT_SCORE = 50.0
    DEFAULT_SCORE_STDDEV = 3.0
    MIN_STD_DEVIATION = 5.0
    STDDEV_QUADRATIC_COEFFICIENT_LESSEQ_12 = DEFAULT_SCORE * DEFAULT_SCORE / DEFAULT_SCORE_STDDEV
    STDDEV_SCORE_ATTR = "Stddev"
    TREND_CHANGE_SCORE_ATTR = "Trend change"
    NEW_APP_PORT_SCORE_ATTR = "New port"
